Tworzenie konta

Aby utworzyć nowe konto klienta, prześlij wstępnie wypełniony Customer obiekt za pomocą metody CreateCustomerClient w usłudze CustomerService.

W przeciwieństwie do standardowego tworzenia encji (np. tworzenia kampanii za pomocą wywołań mutate) w żądaniu musisz podać identyfikator klienta konta menedżera , a nie identyfikator tworzonego klienta.

Pola żądania i klienta

Podczas wywoływania CustomerService.CreateCustomerClient skonfiguruj CreateCustomerClientRequest i jego zagnieżdżony obiekt Customer zgodnie z tabelą poniżej:

Pole lub nagłówek Wymaganie Zmienność i opis
customer_id Wymagane 10-cyfrowy identyfikator klienta (bez łączników) bezpośredniego nadrzędnego konta menedżera , na którym tworzone jest nowe konto klienta.
login-customer-id (nagłówek) Warunkowy Wymagany w nagłówkach żądań, jeśli uwierzytelniony użytkownik uzyskuje dostęp do nadrzędnego konta menedżera (customer_id) za pomocą konta menedżera wyższego w hierarchii.
customer_client.descriptive_name Wymagane Zmienny: nazwa wyświetlana nowego konta (np. "Acct Created with CustomerService"). Można ją później zaktualizować za pomocą CustomerService.MutateCustomer.
customer_client.currency_code Wymagane Niezmienny po utworzeniu: 3-znakowy kod waluty rozliczeniowej ISO 4217 (np. USD lub EUR). Zobacz obsługiwane kody walut.
customer_client.time_zone Wymagane Niezmienny po utworzeniu: identyfikator strefy czasowej konta (np. America/New_York). Zobacz obsługiwane strefy czasowe.
email_address i access_role Opcjonalny (tylko w przypadku listy dozwolonych) Podczas tworzenia zaprasza użytkownika (ADMIN, STANDARD, READ_ONLY lub EMAIL_ONLY) do utworzonego konta. Konta, których nie ma na liście dozwolonych, muszą zapraszać użytkowników po utworzeniu za pomocą CustomerUserAccessInvitationService.
validate_only Opcjonalny Gdy ma wartość true, weryfikuje parametry żądania i kwalifikowalność menedżera bez tworzenia konta.

Przykładowy kod

Poniższy przykład pokazuje, jak utworzyć konto klienta na obecnym koncie menedżera:

Java

private void runExample(GoogleAdsClient googleAdsClient, Long managerId) {
  // Formats the current date/time to use as a timestamp in the new customer description.
  String dateTime = ZonedDateTime.now().format(DateTimeFormatter.RFC_1123_DATE_TIME);

  // Initializes a Customer object to be created.
  Customer customer =
      Customer.newBuilder()
          .setDescriptiveName("Account created with CustomerService on '" + dateTime + "'")
          .setCurrencyCode("USD")
          .setTimeZone("America/New_York")
          // Optional: Sets additional attributes of the customer.
          .setTrackingUrlTemplate("{lpurl}?device={device}")
          .setFinalUrlSuffix("keyword={keyword}&matchtype={matchtype}&adgroupid={adgroupid}")
          .build();

  // Sends the request to create the customer.
  try (CustomerServiceClient client =
      googleAdsClient.getLatestVersion().createCustomerServiceClient()) {
    CreateCustomerClientResponse response =
        client.createCustomerClient(managerId.toString(), customer);
    System.out.printf(
        "Created a customer with resource name '%s' under the manager account with"
            + " customer ID '%d'.%n",
        response.getResourceName(), managerId);
  }
}
      

C#

public void Run(GoogleAdsClient client, long managerCustomerId)
{
    // Get the CustomerService.
    CustomerServiceClient customerService = client.GetService(Services.V26.CustomerService);

    Customer customer = new Customer()
    {
        DescriptiveName = $"Account created with CustomerService on '{DateTime.Now}'",

        // For a list of valid currency codes and time zones see this documentation:
        // https://developers.google.com/google-ads/api/reference/data/codes-formats#codes_formats.
        CurrencyCode = "USD",
        TimeZone = "America/New_York",

        // The below values are optional. For more information about URL
        // options see: https://support.google.com/google-ads/answer/6305348.
        TrackingUrlTemplate = "{lpurl}?device={device}",
        FinalUrlSuffix = "keyword={keyword}&matchtype={matchtype}&adgroupid={adgroupid}"
    };

    try
    {
        // Create the account.
        CreateCustomerClientResponse response = customerService.CreateCustomerClient(
            managerCustomerId.ToString(), customer);

        // Display the result.
        Console.WriteLine($"Created a customer with resource name " +
            $"'{response.ResourceName}' under the manager account with customer " +
            $"ID '{managerCustomerId}'");
    }
    catch (GoogleAdsException e)
    {
        Console.WriteLine("Failure:");
        Console.WriteLine($"Message: {e.Message}");
        Console.WriteLine($"Failure: {e.Failure}");
        Console.WriteLine($"Request ID: {e.RequestId}");
        throw;
    }
}
      

PHP

public static function runExample(GoogleAdsClient $googleAdsClient, int $managerCustomerId)
{
    $customer = new Customer([
        'descriptive_name' => 'Account created with CustomerService on ' . date('Ymd h:i:s'),
        // For a list of valid currency codes and time zones see this documentation:
        // https://developers.google.com/google-ads/api/reference/data/codes-formats.
        'currency_code' => 'USD',
        'time_zone' => 'America/New_York',
        // The below values are optional. For more information about URL
        // options see: https://support.google.com/google-ads/answer/6305348.
        'tracking_url_template' => '{lpurl}?device={device}',
        'final_url_suffix' => 'keyword={keyword}&matchtype={matchtype}&adgroupid={adgroupid}'
    ]);

    // Issues a mutate request to create an account
    $customerServiceClient = $googleAdsClient->getCustomerServiceClient();
    $response = $customerServiceClient->createCustomerClient(
        CreateCustomerClientRequest::build($managerCustomerId, $customer)
    );

    printf(
        'Created a customer with resource name "%s" under the manager account with '
        . 'customer ID %d.%s',
        $response->getResourceName(),
        $managerCustomerId,
        PHP_EOL
    );
}
      

Python

def main(client: GoogleAdsClient, manager_customer_id: str) -> None:
    """The main method that creates all necessary entities for the example.

    Args:
        client: an initialized GoogleAdsClient instance.
        manager_customer_id: a manager client customer ID.
    """
    customer_service: CustomerServiceClient = client.get_service(
        "CustomerService"
    )
    customer: Customer = client.get_type("Customer")
    now: str = datetime.today().strftime("%Y%m%d %H:%M:%S")
    customer.descriptive_name = f"Account created with CustomerService on {now}"
    # For a list of valid currency codes and time zones see this documentation:
    # https://developers.google.com/google-ads/api/reference/data/codes-formats
    customer.currency_code = "USD"
    customer.time_zone = "America/New_York"
    # The below values are optional. For more information about URL
    # options see: https://support.google.com/google-ads/answer/6305348
    customer.tracking_url_template = "{lpurl}?device={device}"
    customer.final_url_suffix = (
        "keyword={keyword}&matchtype={matchtype}&adgroupid={adgroupid}"
    )

    response: CreateCustomerClientResponse = (
        customer_service.create_customer_client(
            customer_id=manager_customer_id, customer_client=customer
        )
    )
    print(
        f'Customer created with resource name "{response.resource_name}" '
        f'under manager account with ID "{manager_customer_id}".'
    )
      

Ruby

def create_customer(manager_customer_id)
  # GoogleAdsClient will read a config file from
  # ENV['HOME']/google_ads_config.rb when called without parameters
  client = Google::Ads::GoogleAds::GoogleAdsClient.new

  customer = client.resource.customer do |c|
    c.descriptive_name = "Account created with CustomerService on #{(Time.new.to_f * 1000).to_i}"

    # For a list of valid currency codes and time zones, see this documentation:
    # https://developers.google.com/google-ads/api/reference/data/codes-formats
    c.currency_code = "USD"
    c.time_zone = "America/New_York"

    # The below values are optional. For more information about URL options, see:
    # https://support.google.com/google-ads/answer/6305348
    c.tracking_url_template = "{lpurl}?device={device}"
    c.final_url_suffix = "keyword={keyword}&matchtype={matchtype}&adgroupid={adgroupid}"
  end

  response = client.service.customer.create_customer_client(
    customer_id: manager_customer_id,
    customer_client: customer
  )

  puts "Created a customer with resource name #{response.resource_name} under" +
      " the manager account with customer ID #{manager_customer_id}."
end
      

Perl

sub create_customer {
  my ($api_client, $manager_customer_id) = @_;

  # Initialize a customer to be created.
  my $customer = Google::Ads::GoogleAds::V26::Resources::Customer->new({
      descriptiveName => "Account created with CustomerService on #" . uniqid(),

      # For a list of valid currency codes and time zones, see this documentation:
      # https://developers.google.com/google-ads/api/reference/data/codes-formats
      currencyCode => "USD",
      timeZone     => "America/New_York",

      # The below values are optional. For more information about URL options, see:
      # https://support.google.com/google-ads/answer/6305348
      trackingUrlTemplate => "{lpurl}?device={device}",
      finalUrlSuffix      =>
        "keyword={keyword}&matchtype={matchtype}&adgroupid={adgroupid}"
  });

  # Create the customer client.
  my $create_customer_client_response =
    $api_client->CustomerService()->create_customer_client({
      customerId     => $manager_customer_id,
      customerClient => $customer
    });

  printf
    "Created a customer with resource name '%s' under the manager account " .
    "with customer ID %d.\n", $create_customer_client_response->{resourceName},
    $manager_customer_id;

  return 1;
}
      

curl

# Creates a customer client.
#
# Variables:
#   API_VERSION,
#   MANAGER_CUSTOMER_ID,
#   OAUTH2_ACCESS_TOKEN:
#     See https://developers.google.com/google-ads/api/rest/auth#request_headers
#     for details.
#
curl -f --request POST \
"https://googleads.googleapis.com/v${API_VERSION}/customers/${MANAGER_CUSTOMER_ID}:createCustomerClient" \
--header "Content-Type: application/json" \
--header "login-customer-id: ${MANAGER_CUSTOMER_ID}" \
--header "Authorization: Bearer ${OAUTH2_ACCESS_TOKEN}" \
--data @- <<EOF
{
  "customerClient": {
    "descriptiveName": "Account created with CustomerService #${RANDOM}",
    "currencyCode": "USD",
    "timeZone": "America/New_York"
  }
}
EOF
      

Odpowiedź i dalsze kroki

W przypadku powodzenia CreateCustomerClient zwraca CreateCustomerClientResponse zawierający resource_name (customers/{new_customer_id}) nowo utworzonego konta (oraz invitation_link, jeśli email_address i access_role konto menedżera na liście dozwolonych zawierało). Następnie możesz użyć tej nazwy zasobu lub identyfikatora klienta, aby zweryfikować konto w hierarchii, przyznać dostęp użytkownikowi, skonfigurować płatności lub wypełnić kampanie.

Weryfikowanie utworzonego konta w hierarchii menedżera

Aby sprawdzić nowo utworzone subkonto, wyślij zapytanie do zasobu customer_client na koncie menedżera (customer_id) za pomocą GoogleAdsService.SearchStream:

SELECT
  customer_client.id,
  customer_client.resource_name,
  customer_client.client_customer,
  customer_client.descriptive_name,
  customer_client.currency_code,
  customer_client.time_zone,
  customer_client.manager,
  customer_client.level,
  customer_client.status
FROM customer_client
WHERE customer_client.level = 1
  AND customer_client.id = {new_customer_id}

Zapraszanie użytkowników do nowego konta

Jeśli Twoje konto menedżera nie znajduje się na liście dozwolonych, na której można ustawić email_address i access_role bezpośrednio w CreateCustomerClientRequest, wyślij zaproszenie do dostępu do nowo utworzonego new_customer_id za pomocą MutateCustomerUserAccessInvitation w CustomerUserAccessInvitationService. Podczas uwierzytelniania za pomocą nadrzędnego konta menedżera dodaj do nagłówków żądania HTTP login-customer-id: {manager_customer_id}:

POST https://googleads.googleapis.com/v26/customers/{new_customer_id}/customerUserAccessInvitations:mutate
{
  "operation": {
    "create": {
      "emailAddress": "user@example.com",
      "accessRole": "ADMIN"
    }
  }
}

Obsługa błędów

Wywołania CreateCustomerClient mogą zwracać te błędy:

  • CustomerError: wskazuje ograniczenia dotyczące tworzenia na poziomie konta, takie jak CREATION_DENIED_INELIGIBLE_MCC (konto menedżera nie kwalifikuje się do tworzenia nowych kont) lub CREATION_DENIED_FOR_POLICY_VIOLATION (tworzenie klienta jest zabronione z powodu naruszenia zasad).
  • ManagerLinkError: wskazuje ograniczenia dotyczące hierarchii lub limitu kont, takie jak TOO_MANY_ACCOUNTS, TOO_MANY_ACCOUNTS_AT_MANAGER, lub MAX_DEPTH_EXCEEDED.
  • AccessInvitationError: zwracany, jeśli w CreateCustomerClientRequest podano opcjonalny email_address (wraz z access_role, dostępny tylko dla kont na liście dozwolonych), aby zaprosić użytkownika do nowego konta, a zaproszenie się nie powiodło (np. INVALID_EMAIL_ADDRESS, GOOGLE_CONSUMER_ACCOUNT_NOT_ALLOWED lub EMAIL_DOMAIN_POLICY_VIOLATED). Konta, których nie ma na liście dozwolonych, powinny zapraszać użytkowników po utworzeniu konta za pomocą CustomerUserAccessInvitationService.
  • CurrencyCodeError.UNSUPPORTED lub TimeZoneError.INVALID_TIME_ZONE: zwracany, gdy podany currency_code lub time_zone w obiekcie Customer jest nieprawidłowy lub nieobsługiwany.